#include <iostream>
#include <string>
#include <vector>
using namespace std;
 
const int MAXN = 100005;
const int MAXT = 4;
 
long long a[MAXN][MAXT];
int n, t, m;
 
vector<long long> algs;
 
long long Hash(string s)
{
    long long result = 0;
    for (int i = 0; i < s.size(); ++ i)
    {
        result = result * 32 + (int)(s[i] - 'A') + 1;
    }
    return result;
}
 
void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
 
    string s;
 
    cin >> n >> t >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j < t; ++ j)
        {
            cin >> s;
            a[i][j] = Hash(s);
        }
    }
}
 
int Go(int l, int r, int step)
{
    int pos = (step < 0) ? r : l;
    while ((step == +1 and pos < r) or (step == -1 and pos > l))
    {
        bool next = false;
 
        for (int i = 0; i < t; ++ i)
        {
            for (int j = 0; j < algs.size(); ++ j)
            {
                if (a[pos + step][i] == algs[j])
                {
                    next = true;
                    i = t; break;
                }
            }
        }
 
        if (next) pos += step;
        else break;
    }
    return pos;
}
 
int CombineL(int l, int r, int li, int ri)
{
    l = Go(li, l, -1);
    r = Go(r, ri, +1);
 
    if (algs.size() == m) return r - l + 1;
 
    if (li < l) l--;
 
    int opt = 0;
    for (int i = 0; i < t; ++ i)
    {
        algs.push_back(a[l][i]);
        opt = max(opt, CombineL(l, r, li, ri));
        algs.pop_back();
    }
    return opt;
}
 
int CombineR(int l, int r, int li, int ri)
{
    l = Go(li, l, -1);
    r = Go(r, ri, +1);
 
    if (algs.size() == m) return r - l + 1;
 
    if (r < ri) r++;
 
    int opt = 0;
    for (int i = 0; i < t; ++ i)
    {
        algs.push_back(a[r][i]);
        opt = max(opt, CombineR(l, r, li, ri));
        algs.pop_back();
    }
    return opt;
}
 
int Sequence(int l = 1, int r = n)
{
    if (r - l + 1 <= m) return r - l + 1;
 
    int mid = (l + r) / 2;
 
    int l_part = Sequence(l, mid + 0);
    int r_part = Sequence(mid + 1, r);
 
    int combl = CombineL(mid + 1, mid + 0, l, r);
    int combr = CombineR(mid + 1, mid + 0, l, r);
 
    return max(max(combl, combr), max(l_part, r_part));
}
 
int main()
{
    Init();
 
    cout << Sequence() << endl;
 
    return 0;
}